Subject: [dtn] I-D Action: draft-ietf-dtn-bpsec-default-sc-05.txt

From: [email-masked]
Date: Mon, 26 Apr 2021 22:05:11 -0700

A New Internet-Draft is available from the on-line Internet-Drafts directories.
This draft is a work item of the Delay/Disruption Tolerant Networking WG of the IETF.

        Title           : BPSec Default Security Contexts
        Authors         : Edward J. Birrane, III
                          Alex White
                          Sarah Heiner
	Filename        : draft-ietf-dtn-bpsec-default-sc-05.txt
	Pages           : 48
	Date            : 2021-04-26

Abstract:
   This document defines default integrity and confidentiality security
   contexts that may be used with the Bundle Protocol Security Protocol
   (BPSec) implementations.  These security contexts are intended to be
   used for both testing the interoperability of BPSec implementations
   and for providing basic security operations when no other security
   contexts are defined or otherwise required for a network.

The IETF datatracker status page for this draft is:
https://datatracker.ietf.org/doc/draft-ietf-dtn-bpsec-default-sc/

There are also htmlized versions available at:
https://tools.ietf.org/html/draft-ietf-dtn-bpsec-default-sc-05
https://datatracker.ietf.org/doc/html/draft-ietf-dtn-bpsec-default-sc-05

A diff from the previous version is available at:
https://www.ietf.org/rfcdiff?url2=draft-ietf-dtn-bpsec-default-sc-05

Please note that it may take a couple of minutes from the time of submission
until the htmlized version and diff are available at tools.ietf.org.

Internet-Drafts are also available by anonymous FTP at:
ftp://ftp.ietf.org/internet-drafts/

---

From: Brian Sipos <[email-masked]>
Date: Wed, 28 Apr 2021 19:50:00 +0000

Ed,
The new examples have good coverage of alternatives and good explanations, but I found a few discrepancies. Here are issues I found in the example of Section A.1:

  1.  There are some uses of the term "CDDL" which really seem to mean "CBOR diagnostic notation". The example figures are not CDDL (a data schema) but diagnostic notation (a text form of decoded CBOR items).
  2.  The abstract security block encodings seem to exclude the top-level array container (encoded as '86' for a six-element array). From BPSec I was under the impression that the ASB was itself an array and not a CBOR sequence.
  3.  The final encoded bundle uses an indefinite-length array container but no ending "break" (encoded as 'FF'), so technically not well-formed CBOR.

Regarding the ASB encoding, I went back to BPSec section 3.6 "Abstract Security Block" and realize that it doesn't explicitly state that the ASB is encoded as an unframed sequence or an array. I had assumed an array in my own implementation of BPSec and for the BPSec-COSE draft. Arrays are slightly easier to handle in user code and in CDDL schema but add a one-octet header (and BPv7 itself uses array framing throughout).
Knowing that BPSec is in the editor queue, is there any value in clarifying this encoding or eventually submitting an errata item about this?
________________________________
From: dtn <[email-masked]> on behalf of [email-masked] <[email-masked]>
Sent: Tuesday, April 27, 2021 01:05
To: [email-masked] <[email-masked]>
Cc: [email-masked] <[email-masked]>
Subject: [dtn] I-D Action: draft-ietf-dtn-bpsec-default-sc-05.txt

Abstract:

The IETF datatracker status page for this draft is:
https://nam10.safelinks.protection.outlook.com/?url=https%3A%2F%2Fdatatracker.ietf.org%2Fdoc%2Fdraft-ietf-dtn-bpsec-default-sc%2F&amp;data=04%7C01%7CBSipos%40rkf-eng.com%7Cb381f3ddf9bf486bbc2908d9093a0d71%7C4ed8b15b911f42bc8524d89148858535%7C1%7C0%7C637550967231288105%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C1000&amp;sdata=ERj8FaovTXhsXRlgQ1UmzbDdBdCPbo4siNswiEKlpv0%3D&amp;reserved=0

There are also htmlized versions available at:
https://nam10.safelinks.protection.outlook.com/?url=https%3A%2F%2Ftools.ietf.org%2Fhtml%2Fdraft-ietf-dtn-bpsec-default-sc-05&amp;data=04%7C01%7CBSipos%40rkf-eng.com%7Cb381f3ddf9bf486bbc2908d9093a0d71%7C4ed8b15b911f42bc8524d89148858535%7C1%7C0%7C637550967231288105%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C1000&amp;sdata=6TjUh6IHi9FmcY4dgVnnoEQPtXKBTRbbVkqUj67VCII%3D&amp;reserved=0
https://nam10.safelinks.protection.outlook.com/?url=https%3A%2F%2Fdatatracker.ietf.org%2Fdoc%2Fhtml%2Fdraft-ietf-dtn-bpsec-default-sc-05&amp;data=04%7C01%7CBSipos%40rkf-eng.com%7Cb381f3ddf9bf486bbc2908d9093a0d71%7C4ed8b15b911f42bc8524d89148858535%7C1%7C0%7C637550967231288105%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C1000&amp;sdata=2LVap1V4yzM6ukiN0AEqV14eOnrlH%2B1tDtdKlbCI1UQ%3D&amp;reserved=0

A diff from the previous version is available at:
https://nam10.safelinks.protection.outlook.com/?url=https%3A%2F%2Fwww.ietf.org%2Frfcdiff%3Furl2%3Ddraft-ietf-dtn-bpsec-default-sc-05&amp;data=04%7C01%7CBSipos%40rkf-eng.com%7Cb381f3ddf9bf486bbc2908d9093a0d71%7C4ed8b15b911f42bc8524d89148858535%7C1%7C0%7C637550967231288105%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C1000&amp;sdata=LIKrsMbfz4EtfvE9NKTzx0ftisx7u8%2FgCCbPM63v5AU%3D&amp;reserved=0

Internet-Drafts are also available by anonymous FTP at:
https://nam10.safelinks.protection.outlook.com/?url=ftp%3A%2F%2Fftp.ietf.org%2Finternet-drafts%2F&amp;data=04%7C01%7CBSipos%40rkf-eng.com%7Cb381f3ddf9bf486bbc2908d9093a0d71%7C4ed8b15b911f42bc8524d89148858535%7C1%7C0%7C637550967231288105%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C1000&amp;sdata=NAwXvZk%2BBev7vz8Kf%2FLnh4oR8r4RfXnQieqFHCVfNaE%3D&amp;reserved=0

_______________________________________________
dtn mailing list
[email-masked]
https://nam10.safelinks.protection.outlook.com/?url=https%3A%2F%2Fwww.ietf.org%2Fmailman%2Flistinfo%2Fdtn&amp;data=04%7C01%7CBSipos%40rkf-eng.com%7Cb381f3ddf9bf486bbc2908d9093a0d71%7C4ed8b15b911f42bc8524d89148858535%7C1%7C0%7C637550967231288105%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C1000&amp;sdata=0LcNDJ4tzIEwojJucoBlQFRG888a9%2Fu6YAITqblVrCQ%3D&amp;reserved=0

---

From: "Birrane, Edward J." <[email-masked]>
Date: Wed, 28 Apr 2021 20:29:57 +0000

Brian,

  Good catches on 1 and 2. I can certainly spin a -06 to address them. Thank you!

  As to the security block block-type-specific-data fields - that is correct, we didn't see a need to add the extra byte for an array wrapper.  I'm not sure what we would clarify regarding that?

-Ed

---
Edward J. Birrane, III, Ph.D.
Embedded Applications Group Supervisor
Space Exploration Sector
Johns Hopkins Applied Physics Laboratory
(W) 443-778-7423 / (F) 443-228-3839

From: Brian Sipos <[email-masked]>
Sent: Wednesday, April 28, 2021 3:50 PM
To: [email-masked]
Cc: Birrane, Edward J. <[email-masked]>
Subject: [EXT] Re: [dtn] I-D Action: draft-ietf-dtn-bpsec-default-sc-05.txt

APL external email warning: Verify sender [email-masked]<mailto:[email-masked]> before clicking links or attachments

Ed,

  1.  There are some uses of the term "CDDL" which really seem to mean "CBOR diagnostic notation". The example figures are not CDDL (a data schema) but diagnostic notation (a text form of decoded CBOR items).
  2.  The abstract security block encodings seem to exclude the top-level array container (encoded as '86' for a six-element array). From BPSec I was under the impression that the ASB was itself an array and not a CBOR sequence.
  3.  The final encoded bundle uses an indefinite-length array container but no ending "break" (encoded as 'FF'), so technically not well-formed CBOR.
Regarding the ASB encoding, I went back to BPSec section 3.6 "Abstract Security Block" and realize that it doesn't explicitly state that the ASB is encoded as an unframed sequence or an array. I had assumed an array in my own implementation of BPSec and for the BPSec-COSE draft. Arrays are slightly easier to handle in user code and in CDDL schema but add a one-octet header (and BPv7 itself uses array framing throughout).
Knowing that BPSec is in the editor queue, is there any value in clarifying this encoding or eventually submitting an errata item about this?
________________________________
From: dtn <[email-masked]<mailto:[email-masked]>> on behalf of [email-masked]<mailto:[email-masked]> <[email-masked]<mailto:[email-masked]>>
Sent: Tuesday, April 27, 2021 01:05
To: [email-masked]<mailto:[email-masked]> <[email-masked]<mailto:[email-masked]>>
Cc: [email-masked]<mailto:[email-masked]> <[email-masked]<mailto:[email-masked]>>
Subject: [dtn] I-D Action: draft-ietf-dtn-bpsec-default-sc-05.txt

Abstract:

_______________________________________________
dtn mailing list
[email-masked]<mailto:[email-masked]>
https://nam10.safelinks.protection.outlook.com/?url=https%3A%2F%2Fwww.ietf.org%2Fmailman%2Flistinfo%2Fdtn&amp;data=04%7C01%7CBSipos%40rkf-eng.com%7Cb381f3ddf9bf486bbc2908d9093a0d71%7C4ed8b15b911f42bc8524d89148858535%7C1%7C0%7C637550967231288105%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C1000&amp;sdata=0LcNDJ4tzIEwojJucoBlQFRG888a9%2Fu6YAITqblVrCQ%3D&amp;reserved=0

---

From: Brian Sipos <[email-masked]>
Date: Wed, 28 Apr 2021 22:09:12 +0000

Ed,
I didn't dig too much into the other example subsections to see if there were similar problems.

Regarding ASB structure: Since there are some additional caveats to decoding a CBOR sequence, specifically in failure modes, a mention of "concatenating CBOR items" (or similar) and a normative reference to RFC 8742 would be helpful. CBOR RFC 8949 just doesn't discuss concatenation/sequence except as an aside in Section 5.1, and I've seen naive CBOR implementations with APIs that make sequence handling more difficult than necessary, so I think it's helpful to make obvious the use here.
________________________________
From: Birrane, Edward J. <[email-masked]>
Sent: Wednesday, April 28, 2021 16:29
To: Brian Sipos <[email-masked]>; [email-masked] <[email-masked]>
Subject: RE: [dtn] I-D Action: draft-ietf-dtn-bpsec-default-sc-05.txt

Brian,

  As to the security block block-type-specific-data fields – that is correct, we didn’t see a need to add the extra byte for an array wrapper.  I’m not sure what we would clarify regarding that?

-Ed

---

Space Exploration Sector

Ed,

Abstract:

The IETF datatracker status page for this draft is:
https://nam10.safelinks.protection.outlook.com/?url=https%3A%2F%2Fdatatracker.ietf.org%2Fdoc%2Fdraft-ietf-dtn-bpsec-default-sc%2F&amp;data=04%7C01%7CBSipos%40rkf-eng.com%7Cb381f3ddf9bf486bbc2908d9093a0d71%7C4ed8b15b911f42bc8524d89148858535%7C1%7C0%7C637550967231288105%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C1000&amp;sdata=ERj8FaovTXhsXRlgQ1UmzbDdBdCPbo4siNswiEKlpv0%3D&amp;reserved=0<https://nam10.safelinks.protection.outlook.com/?url=https%3A%2F%2Fdatatracker.ietf.org%2Fdoc%2Fdraft-ietf-dtn-bpsec-default-sc%2F&data=04%7C01%7CBSipos%40rkf-eng.com%7Ccacdcc65d4eb4eaf2c9b08d90a846630%7C4ed8b15b911f42bc8524d89148858535%7C1%7C0%7C637552386052043044%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C1000&sdata=nmCVJ4TsCh4nqXjrOHC2GEHlKS%2FioqM1SopuzWPuJY8%3D&reserved=0>

There are also htmlized versions available at:
https://nam10.safelinks.protection.outlook.com/?url=https%3A%2F%2Ftools.ietf.org%2Fhtml%2Fdraft-ietf-dtn-bpsec-default-sc-05&amp;data=04%7C01%7CBSipos%40rkf-eng.com%7Cb381f3ddf9bf486bbc2908d9093a0d71%7C4ed8b15b911f42bc8524d89148858535%7C1%7C0%7C637550967231288105%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C1000&amp;sdata=6TjUh6IHi9FmcY4dgVnnoEQPtXKBTRbbVkqUj67VCII%3D&amp;reserved=0<https://nam10.safelinks.protection.outlook.com/?url=https%3A%2F%2Ftools.ietf.org%2Fhtml%2Fdraft-ietf-dtn-bpsec-default-sc-05&data=04%7C01%7CBSipos%40rkf-eng.com%7Ccacdcc65d4eb4eaf2c9b08d90a846630%7C4ed8b15b911f42bc8524d89148858535%7C1%7C0%7C637552386052043044%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C1000&sdata=6q5wPqh0GOZ1%2FBiGdX8C2IqoRVcB5lO9A%2FItINsvMiw%3D&reserved=0>
https://nam10.safelinks.protection.outlook.com/?url=https%3A%2F%2Fdatatracker.ietf.org%2Fdoc%2Fhtml%2Fdraft-ietf-dtn-bpsec-default-sc-05&amp;data=04%7C01%7CBSipos%40rkf-eng.com%7Cb381f3ddf9bf486bbc2908d9093a0d71%7C4ed8b15b911f42bc8524d89148858535%7C1%7C0%7C637550967231288105%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C1000&amp;sdata=2LVap1V4yzM6ukiN0AEqV14eOnrlH%2B1tDtdKlbCI1UQ%3D&amp;reserved=0<https://nam10.safelinks.protection.outlook.com/?url=https%3A%2F%2Fdatatracker.ietf.org%2Fdoc%2Fhtml%2Fdraft-ietf-dtn-bpsec-default-sc-05&data=04%7C01%7CBSipos%40rkf-eng.com%7Ccacdcc65d4eb4eaf2c9b08d90a846630%7C4ed8b15b911f42bc8524d89148858535%7C1%7C0%7C637552386052053042%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C1000&sdata=etYT3U3arwFrHaLWmuc4oY10LMd3xyVkNluhQWGfAME%3D&reserved=0>

A diff from the previous version is available at:
https://nam10.safelinks.protection.outlook.com/?url=https%3A%2F%2Fwww.ietf.org%2Frfcdiff%3Furl2%3Ddraft-ietf-dtn-bpsec-default-sc-05&amp;data=04%7C01%7CBSipos%40rkf-eng.com%7Cb381f3ddf9bf486bbc2908d9093a0d71%7C4ed8b15b911f42bc8524d89148858535%7C1%7C0%7C637550967231288105%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C1000&amp;sdata=LIKrsMbfz4EtfvE9NKTzx0ftisx7u8%2FgCCbPM63v5AU%3D&amp;reserved=0<https://nam10.safelinks.protection.outlook.com/?url=https%3A%2F%2Fwww.ietf.org%2Frfcdiff%3Furl2%3Ddraft-ietf-dtn-bpsec-default-sc-05&data=04%7C01%7CBSipos%40rkf-eng.com%7Ccacdcc65d4eb4eaf2c9b08d90a846630%7C4ed8b15b911f42bc8524d89148858535%7C1%7C0%7C637552386052063032%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C1000&sdata=x%2FZYYXGXxR3s4fLGS1jCv0zm4M3%2BaYgpTpDmXXosIkQ%3D&reserved=0>

Internet-Drafts are also available by anonymous FTP at:
https://nam10.safelinks.protection.outlook.com/?url=ftp%3A%2F%2Fftp.ietf.org%2Finternet-drafts%2F&amp;data=04%7C01%7CBSipos%40rkf-eng.com%7Cb381f3ddf9bf486bbc2908d9093a0d71%7C4ed8b15b911f42bc8524d89148858535%7C1%7C0%7C637550967231288105%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C1000&amp;sdata=NAwXvZk%2BBev7vz8Kf%2FLnh4oR8r4RfXnQieqFHCVfNaE%3D&amp;reserved=0<https://nam10.safelinks.protection.outlook.com/?url=ftp%3A%2F%2Fftp.ietf.org%2Finternet-drafts%2F&data=04%7C01%7CBSipos%40rkf-eng.com%7Ccacdcc65d4eb4eaf2c9b08d90a846630%7C4ed8b15b911f42bc8524d89148858535%7C1%7C0%7C637552386052063032%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C1000&sdata=RuxjDIrQB2f4vI63imUZjYRmf11ZWc7Rt72jJ%2Buc%2B0w%3D&reserved=0>

_______________________________________________
dtn mailing list
[email-masked]<mailto:[email-masked]>
https://nam10.safelinks.protection.outlook.com/?url=https%3A%2F%2Fwww.ietf.org%2Fmailman%2Flistinfo%2Fdtn&amp;data=04%7C01%7CBSipos%40rkf-eng.com%7Cb381f3ddf9bf486bbc2908d9093a0d71%7C4ed8b15b911f42bc8524d89148858535%7C1%7C0%7C637550967231288105%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C1000&amp;sdata=0LcNDJ4tzIEwojJucoBlQFRG888a9%2Fu6YAITqblVrCQ%3D&amp;reserved=0<https://nam10.safelinks.protection.outlook.com/?url=https%3A%2F%2Fwww.ietf.org%2Fmailman%2Flistinfo%2Fdtn&data=04%7C01%7CBSipos%40rkf-eng.com%7Ccacdcc65d4eb4eaf2c9b08d90a846630%7C4ed8b15b911f42bc8524d89148858535%7C1%7C0%7C637552386052073024%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C1000&sdata=%2FWwr6NhLb4L0SWZblbniXq6kgb6uJHOsF7Vx5NUrYQs%3D&reserved=0>

---

From: "R. Atkinson" <[email-masked]>
Date: Thu, 29 Apr 2021 09:54:11 -0400

> On Apr 28, 2021, at 16:29, Birrane, Edward J. <[email-masked]> wrote:
> 

Hi,

For the benefit of interoperability and to help out well-intentioned implementers who are not on this list (e.g., 2 years from now), maybe explicitly say in the document that is it NOT an array, and that it is <whatever format it should be> , if that was the intent/decision.  If there was some other intent/decision, more explicitly document whatever that intent/decision happens to be.

Basically, edit the document to remove the ambiguity that Brian S reported.  The key is to eliminate an ambiguity that could impair interoperability of different implementations.

Yours,

Ran